#ifndef SEGMENT_FUNCTIONS_H
#define	SEGMENT_FUNCTIONS_H
//------------------------------------------------------------------------------
#include "Segments_Prototypes.h"
#include "../../assets/soft_spi/Soft_SPI.h"
#include "../../assets/74HC595/74HC595.h"
//------------------------------------------------------------------------------
void Segment_init()
{
  SPI_init();
}
//------------------------------------------------------------------------------
void Segment_display(signed int number)
{      
  char strNum[10];
  sprintf(strNum,"%4i",number);
  
  for(char pos=0; pos < strlen(strNum); pos++)
  {
    SR_dataSend( getDigit(pos, strNum[pos]) );
    SR_colSelect(pos);
  }
}
//------------------------------------------------------------------------------
char getDigit(char pos,char asciiChar)
{
    char digit = 0;
    
    if(asciiChar >= '0' && asciiChar <= '9')
    {
        char i = asciiChar - '0';
        digit = (pos == 2) ? (digits[i] & DECIMAL_POINT) : digits[i]; //ANDing with DECIMAL_POINT Turns off MSB
    }
    else
        if(asciiChar == '-')
        {
            digit = (pos == 2) ? (digits[0] & DECIMAL_POINT) : 0xBF;  //0xBF - minus symbol
        }
        else
            if(asciiChar == ' ')
            {
                digit = (pos == 2) ? (digits[0] & DECIMAL_POINT) : 0xFF; //0xFF - blank. used for leading zero suppression
            }
    
    return digit;
}
//------------------------------------------------------------------------------
#endif